; ================================================================================================
; Kleiner RGB-Controller fr Tiny2313 mit IR-Fernbedienung RC5
; und 3 Kanlen SW-PWM
;
; "Baumarktfader"
;
; keine Subroutine, wird in den laufenden Text eingebunden, daher keine Register gesichert o..
; ================================================================================================

_Baumarkt:

		lds		temp1, Fade_Speed			; Fade-Geschwindigkeit holen

		rcall	_set_speed					; ggfs. erhhen/verringern

		sts		Fade_Speed, temp1			; Wert speichern
		sts		PGM_Speed, temp1			; und Geschwindigkeit einstellen

		sbrs	Flags, FL_Tick				; Zeitsegment abgelaufen...?
		rjmp	_Baumarkt_Ende				; nein, Modul berspringen
		cbr		Flags, (1<<FL_Tick)			; ja, Flag lschen

		lds		temp0, Fade_State			; aktuelles Fader-Segment holen
		cpi		temp0, 2					; 2 = Fade Blau -> Rot
		breq	_Baumarkt_BR
		cpi		temp0, 1					; 1 = Fade Grn -> Blau
		breq	_Baumarkt_GB
											; 0 = Fade Rot -> Grn

; ------------------------------------------------------------------------------------------------

		clr		temp0						; Blau aus
		sts		temp_B, temp0				; in Farbpuffer ausgeben

		lds		temp0, Fade_G				; Grn holen
		inc		temp0						; und hoch faden
		sts		temp_G, temp0				; in Farbpuffer ausgeben
		sts		Fade_G, temp0				; fr Fader sichern

		lds		temp0, Fade_R				; Rot holen
		dec		temp0						; und runter faden
		sts		temp_R, temp0				; in Farbpuffer ausgeben
		sts		Fade_R, temp0				; fr Fader sichern

		brne	_Baumarkt_Ende				; Fade noch nicht durch, Ausgabe		
		ldi		temp0, 1					; Fade durch, Status eins weiter
		sts		Fade_State, temp0			; speichern
		rjmp	_Baumarkt_Ende				; ausgeben

; ------------------------------------------------------------------------------------------------

_Baumarkt_GB:

		clr		temp0						; Rot aus
		sts		temp_R, temp0				; in Farbpuffer ausgeben

		lds		temp0, Fade_B				; Blau holen
		inc		temp0						; und hoch faden
		sts		temp_B, temp0				; in Farbpuffer ausgeben
		sts		Fade_B, temp0				; fr Fader sichern

		lds		temp0, Fade_G				; Grn holen
		dec		temp0						; und runter faden
		sts		temp_G, temp0				; in Farbpuffer ausgeben
		sts		Fade_G, temp0				; fr Fader sichern

		brne	_Baumarkt_Ende				; Fade noch nicht durch, Ausgabe		
		ldi		temp0, 2					; Fade durch, Status eins weiter
		sts		Fade_State, temp0			; speichern
		rjmp	_Baumarkt_Ende				; ausgeben

; ------------------------------------------------------------------------------------------------

_Baumarkt_BR:

		clr		temp0						; Grn aus
		sts		temp_G, temp0				; in Farbpuffer ausgeben

		lds		temp0, Fade_R				; Rot holen
		inc		temp0						; und hoch faden
		sts		temp_R, temp0				; in Farbpuffer ausgeben
		sts		Fade_R, temp0				; fr Fader sichern

		lds		temp0, Fade_B				; Blau holen
		dec		temp0						; und runter faden
		sts		temp_B, temp0				; in Farbpuffer ausgeben
		sts		Fade_B, temp0				; fr Fader sichern

		brne	_Baumarkt_Ende				; Fade noch nicht durch, Ausgabe		
		ldi		temp0, 0					; Fade durch, Status eins weiter
		sts		Fade_State, temp0			; speichern

; ------------------------------------------------------------------------------------------------

_Baumarkt_Ende:

; ================================================================================================
