; ================================================================================================
; Kleiner RGB-Controller fr Tiny2313/4313 mit IR-Fernbedienung RC5
; und 3 Kanlen SW-PWM
;
; "Blob"
;
; keine Subroutine, wird in den laufenden Text eingebunden, daher keine Register gesichert o..
; ================================================================================================

_Blob:

		lds		temp1, Blob_Speed			; Blob-Geschwindigkeit holen

		rcall	_set_speed					; ggfs. erhhen/verringern

		sts		Blob_Speed, temp1			; Wert speichern
		sts		PGM_Speed, temp1			; und Geschwindigkeit einstellen


		sbrs	Flags, FL_Tick				; Zeitsegment abgelaufen...?
		rjmp	_Blob_Ende					; nein, Modul berspringen
		cbr		Flags, (1<<FL_Tick)			; ja, Flag lschen

		lds		temp2, Blob_State			; Status holen
		tst		temp2						; 0 = runter faden
		breq	_Blob_down

		lds		temp1, Blob_H				; aktuelle Helligkeit holen 
		inc		temp1						; hoch faden
		sts		Blob_H, temp1				; wieder speichern
		cpi		temp1, 255					; Fade am oberen Ende..?
		brne	_Blob_out					; noch nicht durch, Ausgabe

		ldi		temp2, 0					; Fade durch, nchstes mal downfade
		sts		Blob_State, temp2			; speichern
		rjmp	_Blob_out					; Ausgabe

_Blob_down:

		lds		temp1, Blob_H				; aktuelle Helligkeit holen
		dec		temp1						; runter faden
		sts		Blob_H, temp1				; wieder speichern
		cpi		temp1, 0					; unteres Ende erreicht?
		brne	_Blob_out					; noch nicht durch, Ausgabe

		ldi		temp2, 1					; Fade durch, nchstes mal upfade
		sts		Blob_State, temp2			; speichern

_Blob_new_color:							; und neue Farbe aussuchen

		rcall	_Random						; Zufallszahl erzeugen
		mov		temp2, RND_L
		cpi		temp2, 8					; Zahl unter 8...?
		brsh	_Blob_new_color				; nein, noch mal probieren

		sts		Blob_Colour, temp2			; Farbe ausgesucht, speichern

_Blob_out:

		lds		temp1, Blob_H				; Blob-Helligkeit holen
		lds		temp2, Blob_Colour			; Blob-Farbe holen

		clr		temp0
		ldi		ZL, Low(Blob_Farben*2)		; Zeiger auf Blob-Farbtabelle
		ldi		ZH, High (Blob_Farben*2)
		add		ZL, temp2					; Index dazu addieren
		adc		ZH, temp0					; in 16 Bit
		add		ZL, temp2					; 3 mal
		adc		ZH, temp0
		add		ZL, temp2					; da 3 Byte pro Farbe
		adc		ZH, temp0

		lpm		temp0, Z+					; Blob-Farbe Rot holen
		rcall	_Dimmer						; mit Blob-Helligkeit verrechnen
		sts		temp_R, temp0				; und speichern
		lpm		temp0, Z+					; Blob-Farbe Grn holen
		rcall	_Dimmer						; mit Blob-Helligkeit verrechnen
		sts		temp_G, temp0				; und speichern
		lpm		temp0, Z+					; Blob-Farbe Blau holen
		rcall	_Dimmer						; mit Blob-Helligkeit verrechnen
		sts		temp_B, temp0				; und speichern

_Blob_Ende:

; ================================================================================================
