; ================================================================================================
; Kleiner RGB-Controller fr Tiny2313/4313 mit IR-Fernbedienung RC5 und 3 Kanlen SW-PWM
; Konfigurationen
; ================================================================================================

; ================================================================================================
; Ports I/O setzen
; ------------------------------------------------------------------------------------------------

		ldi 	temp0,  (1<<PWM_R) | (1<<PWM_G) | (1<<PWM_B)
		out 	PWM_DDR, temp0				; PWM-Pins auf Ausgang

		sbi		SLED_DDR, SLED				; Status-LED auf Ausgang
		sbi		SLED_OUT, SLED				; Status-LED an

		sbi		RC5_OUT, RC5				; Pullup fr RC5-Empfnger

		ser		temp0						; Pullups fr DIPS 1-8
		out		DIP_OUT, temp0
		sbi		DIP9_OUT, DIP9				; Pullup fr DIP 9

		sbi		PortD,0						; Pullup fr Rx-Pin

; ================================================================================================
; Stackpointer
; ------------------------------------------------------------------------------------------------

		ldi 	temp0, LOW(RAMEND)			; Low-Byte der obersten RAM-Adresse
		out 	SPL, temp0					; Stackpointer setzen

; ================================================================================================
; Timer0 initialisieren
; ------------------------------------------------------------------------------------------------

		ldi     temp0, (1<<CS00)			; CS00 setzen: Prescaler 1, Timer starten
		out     TCCR0, temp0

		ldi     temp0, (1<<TOIE0)      		; TOIE0: Interrupt bei Timer0 Overflow fr ISR
		out     TIMSK, temp0

; ================================================================================================
; Konfiguration aus EEPROM holen
; ------------------------------------------------------------------------------------------------

		rcall	_Load_Config

; ================================================================================================
; DMX konfigurieren
; ------------------------------------------------------------------------------------------------

.include "DMX_Setup.inc"					; Setup-Routine einbinden

; ================================================================================================
; Zufallszahlengenerator initialisieren
; ------------------------------------------------------------------------------------------------

		ldi		temp0, 0b01100011			; Startwert Zufallszahlengenerator
		mov		RND_L, temp0
		mov		RND_H, temp0

; ================================================================================================
; Speicher fr empfangene Befehle und Flags lschen, Startwerte
; ------------------------------------------------------------------------------------------------

		clr		temp0						; zuletzt empfangenen Befehl lschen
		sts		rc5_device, temp0
		sts		rc5_last_command, temp0

		clr		Flags						; Flags lschen

; ================================================================================================

		sei									; Interrupts aktivieren

; ================================================================================================
