; ================================================================================================
; Kleiner RGB-Controller fr Tiny2313/4313 mit IR-Fernbedienung RC5 und 3 Kanlen SW-PWM
; DMX-Setup
; ================================================================================================

_DMX_Setup:

; ================================================================================================
; USART konfigurieren fr DMX
; ------------------------------------------------------------------------------------------------

.equ UBRR_VAL =((XTAL+BAUD*8)/(BAUD*16)-1)  	; UBBR ausrechnen

	   	ldi 	temp0, UBRR_VAL					; Usart auf Baudrate setzen
    	out 	UBRRL, temp0
    	clr 	temp0
    	out 	UBRRH, temp0

    	ldi 	temp0, (3<<UCSZ0)|(1<<USBS)	 	; 8 Datenbits, 2 Stoppbits
    	out 	UCSRC, temp0			

		sbi 	UCSRB, RXEN						; Receiver enable
		sbi 	UCSRB, RXCIE					; RX Complete Int. enable

; ================================================================================================
; Startwerte
; ------------------------------------------------------------------------------------------------

		clr		DMX_state						; Start-Status: auf Frame-Error warten

		ser		temp0							; DMX-Empfangspuffer auf "Rot"
		sts		(DMX_In), temp0
		clr		temp0
		sts		(DMX_In+1), temp0
		sts		(DMX_In+2), temp0

; ================================================================================================
; DMX-Startadresse einstellen
; ------------------------------------------------------------------------------------------------

		in		temp0, DIP_IN					; DIP 1-8 holen
		com		temp0							; "Umdrehen", da Schalter nach GND

		clr		temp1							; High-Byte DMX-Startadresse
		sbis	DIP9_IN, DIP9					; Schalter an?
		ldi		temp1, 1						; ja, High-Byte auf 1

		clr		temp2							; auf Startadresse "0" prfen
		add		temp2, temp0					; low-Byte
		add		temp2, temp1					; high-Byte
		brne	_set_dmx_adress					; Adresse <> 0, ausgeben

		rjmp	_dont_set_dmx_adress

_set_dmx_adress:

		sts		DMX_Start_L, temp0
		sts		DMX_Start_H, temp1

_dont_set_dmx_adress:

; ================================================================================================
