; ================================================================================================
; Kleiner RGB-Controller fr Tiny2313 mit IR-Fernbedienung RC5 und 3 Kanlen SW-PWM
; Daten im Flash und EEPROM
; ================================================================================================

; ------------------------------------------------------------------------------------------------
; Farbtabellen
; ------------------------------------------------------------------------------------------------

.equ FC_COUNT = 16							; Zahl der Farben in Tabelle

fixed_colour_values:

	.db		255, 000, 000, 	255, 070, 000	; Rot + Orange
	.db		255, 240, 000, 	000, 255, 000	; Gelb + Grn
	.db		000, 255, 235, 	000, 000, 255	; Trkis + Blau
	.db		255, 000, 255, 	230, 100, 255	; Magenta + Flieder
	.db		030, 255, 120, 	255, 150, 130	; Smaragd + Rosa
	.db		040,  90, 255, 	 90, 240, 000	; Hellblau + Oliv
	.db		255, 240, 025, 	250, 000, 200	; Gold + Purpur
	.db		255, 255, 255, 	255, 210, 140	; Wei + Warmwei

Blob_Farben:

	.db 	0xFF, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00
	.db 	0xFF, 0x00, 0xFF, 0xEF, 0xFF, 0x00, 0xEF, 0xFF
	.db 	0xFF, 0x00, 0xFF, 0x30, 0x00, 0x30, 0xFF, 0x00

; ================================================================================================
; Daten im EEPROM
; ------------------------------------------------------------------------------------------------

.ESEG


EEP_Conf_Data:

	.db		  6,	 31					; Programm-Nummer				; Master-Dimmer
	.db		255,	  0					; Geschw. aktuelles Programm	; aktuelle feste Farbe
	.db		  0,	255					; Fader Status					; Fader Rot-Kanal
	.db		  0,	  0					; Fader Grn-Kanal				; Fader Blau-Kanal
	.db		100,	  0					; Fader Geschwindigkeit			; Aktuelle Blob-Farbnummer
	.db		 20,	  1					; Blob Geschwindigkeit			; Blob-Helligkeit
	.db		  1,	 40					; Blob up oder down				; Kaminfeuer Geschwindigkeit
	.db		250,	low(DMX_STARTADRESS); Kaminfeuer letzte Helligkeit	; DMX Start L
	.db	high(DMX_STARTADRESS),	255		; DMX Start H					; Random Fade Speed
	.db		100,	170					; Random Fade Rot				; Random Fade Grn
	.db		 80,	200					; Random Fade Blau				; Random Fade Rot Max
	.db		210,	230					; Random Fade Grn Max			; Random Fade Blau Max
	.db		  2,	180					; Random Fade Status			; Gewitter Geschwindigkeit

; ================================================================================================
