; ================================================================================================
; Kleiner RGB-Controller fr Tiny2313 mit IR-Fernbedienung RC5
; und 3 Kanlen SW-PWM
;
; "Kaminfeuer"
;
; keine Subroutine, wird in den laufenden Text eingebunden, daher keine Register gesichert o..
; ================================================================================================
; Einstellungen:

.equ	FIRE_BASE			= 160			; *** Grundhelligkeit ***
.equ	FIRE_GREEN_AMOUNT	= 180			; *** Maximalanteil Grn ***
.equ	FIRE_UPFLAME		= 60			; *** maximaler Helligkeitszuwachs ***
.equ	FIRE_DOWNFLAME		= 30			; *** maximaler Helligkeitsabfall ***

; ================================================================================================


_Fire:

		lds		temp1, Fire_Speed			; Fire-Geschwindigkeit holen

		rcall	_set_speed					; ggfs. erhhen/verringern

		sts		Fire_Speed, temp1			; Wert speichern
		sts		PGM_Speed, temp1			; und Geschwindigkeit einstellen

		sbrs	Flags, FL_Tick				; Zeitsegment abgelaufen...?
		rjmp	_Fire_Ende					; nein, Modul berspringen
		cbr		Flags, (1<<FL_Tick)			; ja, Flag lschen

		clr		temp1						; Blau immer aus
		sts		temp_B, temp1

_Fire_Loop:

		rcall	_Random						; Zufallszahl fr Rot erzeugen
		mov		temp1, RND_H
		cpi		temp1, FIRE_BASE			; *** Grundhelligkeit ***
		brlo	_Fire_Loop

		mov		temp3, temp1				; Wert kopieren zum rechnen

		lds		temp2, Fire_H				; letzte Helligkeit holen
		cp		temp2, temp3				; letzter oder aktueller Wert heller?	
		brsh	_letzter_heller

		sub		temp3, temp2				; Differenz berechnen
		cpi		temp2, FIRE_UPFLAME			; *** maximaler Unterschied heller***
		brsh	_Fire_Ende					; Unterschied zu gro, verwerfen

		rjmp	_Fire_green					; passt, Grn berechnen

_letzter_heller:

		sub		temp2, temp3				; Differenz berechnen
		cpi		temp2, FIRE_DOWNFLAME		; *** maximaler Unterschied dunkler ***
		brsh	_Fire_Ende					; Unterschied zu gro, verwerfen

_Fire_green:

		sts		temp_R, temp1				; Rot sichern

_Fire_Random_Loop:

		rcall	_Random						; Zufallszahl fr Grn erzeugen
		cp		temp1, RND_H				; Grn darf max. so hell sein wie Rot
		brlo	_Fire_Random_Loop

		ldi		temp1, FIRE_GREEN_AMOUNT	; *** Grn weiter runter dimmen ***
		mov		temp0, RND_H
		rcall	_Dimmer
		sts		temp_G, temp0				; Grn sichern

_Fire_Ende:

; ================================================================================================
