; ================================================================================================
; Kleiner RGB-Controller fr Tiny2313 mit IR-Fernbedienung RC5
; und 3 Kanlen SW-PWM
;
; "Feste Farbe"
;
; keine Subroutine, wird in den laufenden Text eingebunden, daher keine Register gesichert o..
; ================================================================================================

_Fixed_Colour:

		lds		temp1, FC_Colour			; eingestellte Farbe holen

		ldi		ZL, Low(fixed_colour_values*2)	; Zeiger auf Festfarben-Tabelle
		ldi		ZH, High (fixed_colour_values*2)

		clr		temp0
		add		ZL, temp1					; Index dazu addieren
		adc		ZH, temp0					; in 16 Bit
		add		ZL, temp1					; 3 mal
		adc		ZH, temp0
		add		ZL, temp1					; da 3 Byte pro Farbe
		adc		ZH, temp0

		lpm		temp0, Z+					; Festfarbe Rot holen
		sts		temp_R, temp0				; und speichern
		lpm		temp0, Z+					; Festfarbe Grn holen
		sts		temp_G, temp0				; und speichern
		lpm		temp0, Z+					; Festfarbe Blau holen
		sts		temp_B, temp0				; und speichern

; ------------------------------------------------------------------------------------------------

		sbrc	Flags, FL_RC5_HOLD			; Taste gehalten?
		rjmp	_Fixed_Colour_Ende			; Ja, Ende

		sbrs	Flags, FL_RC5				; RC5-Befehl empfangen...?
		rjmp	_Fixed_Colour_Ende			; nein, Auswertung berspringen

		lds		temp2, rc5_last_command		; ja, Befehl holen

		cpi		temp2, SPEED_UP				; Taste fr nchste Farbe gedrckt..?
		breq	_fc_up						; ja, nchste Farbe

		cpi		temp2, SPEED_DOWN			; Taste fr vorherige Farbe gedrckt..?
		breq	_fc_down					; ja, vorherige Farbe

		rjmp	_Fixed_Colour_Ende			; anderer Befehl, Ende

_fc_up:
		cpi		temp1, (FC_COUNT-1)			; Maximalwert schon erreicht...?
		brsh	_Fixed_Colour_Ende			; ja, nicht ndern
		
		inc		temp1						; nein, erhhen
		rjmp	_save_fc					; und speichern

_fc_down:

		cpi		temp1, 0					; Minimalwert schon erreicht...?
		breq	_Fixed_Colour_Ende			; ja, nicht ndern
		
		dec		temp1						; nein, verringern

_save_fc:

		sts		FC_Colour, temp1			; neu eingestellte Farbe speichern

_Fixed_Colour_Ende:

; ================================================================================================
