; ================================================================================================
; RC5-Kommando holen, Flags setzen fr empfangen und Toggle-Bit
; ================================================================================================

_Get_RC5:

		push	temp0
		push	temp1

		cli									; Ausfhrung atomar, damit Empfangsroutine nicht
											; Device und Comm. aus versch. Frames speichert

		lds		temp0, rc5_device

		cbr		Flags, (1<<FL_RC5)			; Flag fr Befehl empfangen lschen

		sbrs	temp0, 7					; neuer Befehl empfangen?
		rjmp 	_Get_RC5_Ende				; nein, Ende

		bst		temp0, 5					; ja, empfangenes Toggle-Bit speichern

		andi	temp0, 0b00011111			; Nur Device interessiert
		sts		rc5_last_device, temp0		; sichern fr evtl. sptere Auswertung

		cpi		temp0, DEVICE				; mit gewnschtem Device vergleichen
		brne	_Get_RC5_Ende				; falsches Device, Ende

		sbr		Flags, (1<<FL_RC5)			; richtiges Device, Flag fr Befehl empfangen setzen
		bld		Flags, FL_RC5_TOGGLE		; empfangenes Toggle-Bit bertragen

		mov		temp0, Last_Toggle			; zuletzt empfangenes Toggle-Bit
		mov		temp1, Flags				; Aktuelles Toggle-Bit
		andi	temp1, (1<<FL_RC5_TOGGLE)	; nur das Bit
		mov		Last_Toggle, temp1			; fr nchsten Vergleich sichern

		eor		temp0, temp1				; letztes mit aktuellem Toggle vergleichen

		sbrs	temp0, FL_RC5_TOGGLE		; Bits gleich ?
		sbr		Flags, (1<<FL_RC5_HOLD)		; ja, Taste wurde gehalten
		sbrc	temp0, FL_RC5_TOGGLE		; Bits gleich ?
		cbr		Flags, (1<<FL_RC5_HOLD)		; ja, Taste wurde nicht gehalten

		clr		temp0						; auf nchsten Befehl warten
		sts		rc5_device, temp0
		
		lds		temp0, rc5_command			; zuletzt empfangenen Befehl fr Auswertung sichern
		sts		rc5_last_command, temp0		; da die Empfangsroutine "dazwischen hauen" kann

_Get_RC5_Ende:
			
		sei									; Interrupts wieder aktivieren

		pop		temp1
		pop		temp0

		ret

; ================================================================================================
