; ================================================================================================
; Kleiner RGB-Controller fr Tiny2313 mit IR-Fernbedienung RC5
; und 3 Kanlen SW-PWM
; ================================================================================================

; ================================================================================================
; Timer0-ISR fr PWM, Zeitbasis und RC5-Empfang
; ------------------------------------------------------------------------------------------------

_ISR_Timer0OVF:

		push	temp0
		in		temp0, SREG					; Statusregister sichern
		push	temp0

		rcall	_sw_pwm						; SW-PWM

		rcall	_rc5_receiver				; FB abfragen

		mov		temp0, PWM_Count			; PWM-Zhler luft durch (increment alle 256 Takte)
		andi	temp0, 0b00001111			; nur letzte 4 Bits = Teilen mit Rest durch 16		
		brne	_ISR_Timer0OVF_Ende			; nicht glatt geteilt, Ende

		dec		Timebase					; glatt geteilt, Zeitbasis runterzhlen
		brne	_ISR_Timer0OVF_Ende			; noch nicht 0, Ende
		
		lds		Timebase, PGM_Speed			; 0 erreicht, Zhler neu laden
		sbr		Flags, (1<<FL_Tick)			; und Flag setzen fr Segment abgelaufen

_ISR_Timer0OVF_Ende:

		pop		temp0						; Statusregister wiederherstellen
		out		SREG, temp0
		pop		temp0
		reti								; und zurck

; ================================================================================================
