; ================================================================================================
; Kleiner RGB-Controller fr Tiny2313 mit IR-Fernbedienung RC5 und 3 Kanlen SW-PWM
; Auswertung der empfangenen Befehle
; ================================================================================================

; ================================================================================================
; Auswertung globaler Befehle - Geschwindigkeit in eigener Routine, da in jedem Programm extra
; ------------------------------------------------------------------------------------------------

_key_command:

		push	temp0
		push	temp2

; ================================================================================================
; empfangene Befehle auswerten
; ------------------------------------------------------------------------------------------------

		lds		temp0, PGM_Number			; Programm-Nummer holen
		mov		Last_PGM, temp0				; Alte Programm-Nr. sichern

		lds		temp0, Dimmer				; Master-Dimmer holen

		lds		temp2, rc5_last_command		; Befehl holen

; ------------------------------------------------------------------------------------------------

		cpi		temp2, BRI_UP				; Taste heller gedrckt?
		brne	_key_select_1				; nein, nchste Abfrage

		cpi		temp0, BRI_MAX				; Maximalwert schon erreicht...?
		brlo	_set_bright_up				; nein, erhhen
		rjmp	_key_command_ende			; ja, nicht ndern

_set_bright_up:
	
		inc		temp0						; Helligkeit erhhen
		rjmp	_dimmer_out					; und Speichern

; ------------------------------------------------------------------------------------------------

_key_select_1:

		cpi		temp2, BRI_DOWN				; Taste dunkler gedrckt?
		brne	_key_select_2				; nein, nchste Abfrage

		tst		temp0						; Minimalwert schon erreicht...?
		breq	_key_command_ende			; ja, nicht ndern

_set_bright_down:
		
		dec		temp0						; Helligkeit verringern
		rjmp	_dimmer_out					; und Speichern

; ------------------------------------------------------------------------------------------------

_key_select_2:

		cpi		temp2, SAVE					; Taste speichern gedrckt?
		brne	_key_select_3				; nein, nchste Abfrage

		rcall	_Save						; ja, Einstellungen speichern

		rjmp	_key_command_ende			; und weiter im Programm

; ------------------------------------------------------------------------------------------------

_key_select_3:

		cpi		temp2, OFF					; Taste Off gedrckt?
		brne	_key_select_4				; nein, nchste Abfrage

		ldi		temp0, 255					; ja, Programm 255 (Ausschalten) einstellen
		rjmp	_key_command_store			; und Speichern

; ------------------------------------------------------------------------------------------------

_key_select_4:

		cpi		temp2, PGM_CHANGE			; Taste Programm Weiter gedrckt?
		brne	_key_select_5				; nein, nchste Abfrage

		sbrc	Flags, FL_RC5_HOLD			; Taste gehalten?
		rjmp	_key_command_ende			; Ja, Ende

		lds		temp0, PGM_Number			; ja, Programm-Nummer holen
		inc		temp0						; Programm weiter zhlen
		cpi		temp0, PGM_COUNT			; grte Nummer erreicht?
		brlo	_key_command_store			; nein, Speichern

		clr		temp0						; ja, auf 0 zurck setzen
		rjmp	_key_command_store			; und Speichern

; ------------------------------------------------------------------------------------------------

_key_select_5:

		cpi		temp2, PGM_0				; Taste Programm 0 gedrckt?
		brne	_key_select_6				; nein, nchste Abfrage

		ldi		temp0, 0					; ja, Programm 0 einstellen
		rjmp	_key_command_store			; und Speichern

; ------------------------------------------------------------------------------------------------

_key_select_6:

		cpi		temp2, PGM_1				; Taste Programm 1 gedrckt?
		brne	_key_select_7				; nein, nchste Abfrage

		ldi		temp0, 1					; ja, Programm 1 einstellen
		rjmp	_key_command_store			; und Speichern

; ------------------------------------------------------------------------------------------------

_key_select_7:

		cpi		temp2, PGM_2				; Taste Programm 2 gedrckt?
		brne	_key_select_8				; nein, nchste Abfrage

		ldi		temp0, 2					; ja, Programm 2 einstellen
		rjmp	_key_command_store			; und Speichern

; ------------------------------------------------------------------------------------------------

_key_select_8:

		cpi		temp2, PGM_3				; Taste Programm 3 gedrckt?
		brne	_key_select_9				; nein, nchste Abfrage

		ldi		temp0, 3					; ja, Programm 3 einstellen
		rjmp	_key_command_store			; und Speichern

; ------------------------------------------------------------------------------------------------

_key_select_9:

		cpi		temp2, PGM_4				; Taste Programm 4 gedrckt?
		brne	_key_select_10				; nein, nchste Abfrage

		ldi		temp0, 4					; Programm 4 einstellen
		rjmp	_key_command_store			; und Speichern

; ------------------------------------------------------------------------------------------------

_key_select_10:

		cpi		temp2, PGM_5				; Taste Programm 5 gedrckt?
		brne	_key_select_11				; nein, nchste Abfrage

		ldi		temp0, 5					; ja, Programm 5 einstellen
		rjmp	_key_command_store			; und Speichern

; ------------------------------------------------------------------------------------------------

_key_select_11:

		cpi		temp2, PGM_6				; Taste Programm 6 gedrckt?
		brne	_key_select_end				; nein, nchste Abfrage

		ldi		temp0, 6					; ja, Programm 6 einstellen
		rjmp	_key_command_store			; und Speichern

; ------------------------------------------------------------------------------------------------

_key_select_end:

		rjmp	_key_command_ende			; undefinierter Befehl, Ende

; ================================================================================================

_dimmer_out:

		sts		Dimmer,temp0				; Dimmer speichern
		rjmp	_key_command_ende			; und Ende

; ------------------------------------------------------------------------------------------------

_key_command_store:

		sts		PGM_Number,temp0			; Programm speichern

		sbi		SLED_OUT, SLED				; Status-LED an

_key_command_ende:

		pop		temp2
		pop		temp0

		ret

; ================================================================================================

