; ================================================================================================
; Kleiner RGB-Controller fr Tiny2313/4313 mit IR-Fernbedienung RC5
; und 3 Kanlen SW-PWM
;
; "Gewitter"
;
; keine Subroutine, wird in den laufenden Text eingebunden, daher keine Register gesichert o..
; ================================================================================================
; Einstellungen:

.equ LG_DARK = 20							; Helligkeit "Nachthimmel" (Blau)
.equ LG_FLASH_COUNT = 20					; Hufigkeit "Blitze"
.equ LG_FLASH_MIN = 100						; Minimale Helligkeit "Blitze"

; ================================================================================================

_Lightning:

		lds		temp1, Lightning_Speed		; Geschwindigkeit holen

		rcall	_set_speed					; ggfs. erhhen/verringern

		sts		Lightning_Speed, temp1		; Wert speichern
		sts		PGM_Speed, temp1			; und Geschwindigkeit einstellen

		sbrs	Flags, FL_Tick				; Zeitsegment abgelaufen...?
		rjmp	_Lightning_Finish			; nein, Modul berspringen
		cbr		Flags, (1<<FL_Tick)			; ja, Flag lschen

; ------------------------------------------------------------------------------------------------

		clr		temp0						; Rot und Grn aus
		sts		temp_R, temp0
		sts		temp_G, temp0
		ldi		temp0, LG_DARK				; Blau auf eingestellten Wert

		rcall	_Random						; Zufallszahl erzeugen
		mov		temp0, RND_L

		cpi		temp0, LG_FLASH_COUNT		; Blitz nur, wenn Zahl im Fenster
		brsh	_Lightning_Finish			; Zahl zu gro, Ende

_Lightning_new:

		rcall	_Random						; Zufallszahl erzeugen
		mov		temp0, RND_L

		cpi		temp0, LG_FLASH_MIN			; minimale Helligkeit Blitz erreicht?
		brlo	_Lightning_new				; nein, neue Helligkeit erzeugen

		sts		temp_R, temp0				; ja, wei ausgeben (= "Blitz")
		sts		temp_G, temp0
		sts		temp_B, temp0

; ------------------------------------------------------------------------------------------------

_Lightning_Finish:

; ================================================================================================
