; ================================================================================================
; Kleiner RGB-Controller fr Tiny2313 mit IR-Fernbedienung RC5
; und 3 Kanlen SW-PWM
;
; "Ausschalten" -> es werden einfach alle LEDs auf 0 gesetzt, Status-LED blitzt ca. alle 3 Sek.
;
; keine Subroutine, wird in den laufenden Text eingebunden, daher keine Register gesichert o..
; ================================================================================================

_Off:

		clr		temp1						; LEDs aus
		sts		PWM_Buffer, temp1
		sts		(PWM_Buffer+1), temp1
		sts		(PWM_Buffer+2), temp1

_sleep:

		cbi		SLED_OUT,SLED				; Status-LED aus

		ldi		temp1, 15					; Pause zwischen den Blitzern

_sleep0:

		rcall	_Get_RC5					; Prfen, ob neuer Befehl

		sbrs	Flags, Fl_RC5				; neuer Befehl angekommen?
		rjmp	_sleep_on					; nein, weiter "schlafen"

		lds		temp0, rc5_command			; ja, Befehl holen
		cpi		temp0, OFF					; Ausschalter gedrckt?
		breq	_sleep_on					; ja, weiter "schlafen"

		rjmp	_wakeup						; nein, andere Taste, wieder "aufwachen"

_sleep_on:

		rcall	_wait_200ms
		dec		temp1
		brne	_sleep0

		sbi		SLED_OUT,SLED				; Status-LED an
		rcall	_wait_200ms					; fr 200 ms = "Blitzen"

		rjmp	_sleep						; weiter "schlafen"

_wakeup:

		sbi		SLED_OUT,SLED				; Status-LED wieder einschalten
		sts		PGM_Number, Last_PGM		; vor dem Ausschalten zuletzt aktives Programm einst.
		sts		rc5_device, temp0			; RC5-Empfnger lschen, damit keine nderung

; ================================================================================================
