; ================================================================================================
; Kleiner RGB-Controller fr Tiny2313/4313 mit IR-Fernbedienung RC5
; und 3 Kanlen SW-PWM
;
; "Zufallsfader"
;
; keine Subroutine, wird in den laufenden Text eingebunden, daher keine Register gesichert o..
; ================================================================================================
; Definitionen:
;
.equ RF_ST_R = 0							; Status Rot (0 = rauf, 1 = runter)
.equ RF_ST_G = 1							; Status Grn (0 = rauf, 1 = runter)
.equ RF_ST_B = 2							; Status Blau (0 = rauf, 1 = runter)

.equ RF_MIN	= 200							; Minimale Helligkeit

; ================================================================================================

_Random_Fade:

		lds		temp1, Random_Fade_Speed	; Geschwindigkeit holen

		rcall	_set_speed					; ggfs. erhhen/verringern

		sts		Random_Fade_Speed, temp1	; Wert speichern
		sts		PGM_Speed, temp1			; und Geschwindigkeit einstellen


		sbrs	Flags, FL_Tick				; Zeitsegment abgelaufen...?
		rjmp	_Random_Fade_Finish			; nein, Modul berspringen
		cbr		Flags, (1<<FL_Tick)			; ja, Flag lschen

		lds		temp2, RF_State				; Status holen, bleibt in temp2

; ------------------------------------------------------------------------------------------------
; Rot faden
; ------------------------------------------------------------------------------------------------

		lds		temp1, RF_R					; aktuelle Helligkeit Rot holen 

		sbrs	temp2, RF_ST_R
		rjmp	_RF_R_Down					; 0 = runter faden

		lds		temp0, RF_R_MAX				; maximale Helligkeit holen
		inc		temp1						; Rot hoch faden
		cp		temp1, temp0				; Fade am oberen Ende..?
		brlo	_RF_Fade_R_End				; noch nicht durch, weiter
		cbr		temp2, (1<<RF_ST_R)			; Fade durch, nchstes mal downfade
		rjmp	_RF_Fade_R_End				; weiter

_RF_R_Down:

		dec		temp1						; runter faden
		brne	_RF_Fade_R_End				; noch nicht durch, weiter

		sbr		temp2, (1<<RF_ST_R)			; Fade durch, nchstes mal upfade

_RF_R_new_color:							; und neue Helligkeit aussuchen

		rcall	_Random						; Zufallszahl erzeugen
		mov		temp0, RND_L
		cpi		temp0, RF_MIN				; Zahl ber minimale Helligkeit...?
		brlo	_RF_R_new_color				; nein, noch mal probieren

		sts		RF_R_MAX, temp0				; Helligkeit ausgesucht, speichern

_RF_Fade_R_End:

		sts		RF_R, temp1					; aktuelle Helligkeit wieder speichern
		sts		temp_R, temp1				; und in Ausgabepuffer schreiben

; ------------------------------------------------------------------------------------------------
; Grn faden
; ------------------------------------------------------------------------------------------------

		lds		temp1, RF_G					; aktuelle Helligkeit Grn holen 

		sbrs	temp2, RF_ST_G
		rjmp	_RF_G_Down					; 0 = runter faden

		lds		temp0, RF_G_MAX				; maximale Helligkeit holen
		inc		temp1						; Grn hoch faden
		cp		temp1, temp0				; Fade am oberen Ende..?
		brlo	_RF_Fade_G_End				; noch nicht durch, weiter
		cbr		temp2, (1<<RF_ST_G)			; Fade durch, nchstes mal downfade
		rjmp	_RF_Fade_G_End				; weiter

_RF_G_Down:

		dec		temp1						; runter faden
		brne	_RF_Fade_G_End				; noch nicht durch, weiter

		sbr		temp2, (1<<RF_ST_G)			; Fade durch, nchstes mal upfade

_RF_G_new_color:							; und neue Helligkeit aussuchen

		rcall	_Random						; Zufallszahl erzeugen
		mov		temp0, RND_L
		cpi		temp0, RF_MIN				; Zahl ber minimale Helligkeit...?
		brlo	_RF_G_new_color				; nein, noch mal probieren

		sts		RF_G_MAX, temp0				; Helligkeit ausgesucht, speichern

_RF_Fade_G_End:

		sts		RF_G, temp1					; aktuelle Helligkeit wieder speichern
		sts		temp_G, temp1				; und in Ausgabepuffer schreiben

; ------------------------------------------------------------------------------------------------
; Blau faden
; ------------------------------------------------------------------------------------------------

		lds		temp1, RF_B					; aktuelle Helligkeit Blau holen 

		sbrs	temp2, RF_ST_B
		rjmp	_RF_B_Down					; 0 = runter faden

		lds		temp0, RF_B_MAX				; maximale Helligkeit holen
		inc		temp1						; Blau hoch faden
		cp		temp1, temp0				; Fade am oberen Ende..?
		brlo	_RF_Fade_B_End				; noch nicht durch, weiter
		cbr		temp2, (1<<RF_ST_B)			; Fade durch, nchstes mal downfade
		rjmp	_RF_Fade_B_End				; weiter

_RF_B_Down:

		dec		temp1						; runter faden
		brne	_RF_Fade_B_End				; noch nicht durch, weiter

		sbr		temp2, (1<<RF_ST_B)			; Fade durch, nchstes mal upfade

_RF_B_new_color:							; und neue Helligkeit aussuchen

		rcall	_Random						; Zufallszahl erzeugen
		mov		temp0, RND_L
		cpi		temp0, RF_MIN				; Zahl ber minimale Helligkeit...?
		brlo	_RF_B_new_color				; nein, noch mal probieren

		sts		RF_B_MAX, temp0				; Helligkeit ausgesucht, speichern

_RF_Fade_B_End:

		sts		RF_B, temp1					; aktuelle Helligkeit wieder speichern
		sts		temp_B, temp1				; und in Ausgabepuffer schreiben

; ------------------------------------------------------------------------------------------------

		sts		RF_State, temp2				; Status wieder speichern

_Random_Fade_Finish:

; ================================================================================================
