; ================================================================================================
; Kleiner RGB-Controller fr Tiny2313 mit IR-Fernbedienung RC5 und 3 Kanlen SW-PWM
; Geschwindigkeit (befindet sich in temp1) einstellen
;
; Register werden nicht gesichert, da per include im Hauptprogramm eingebunden
; ================================================================================================

_set_speed:

		sbrs	Flags, FL_RC5				; RC5-Befehl empfangen...?
		rjmp	_set_speed_nochange			; nein, Auswertung berspringen

		lds		temp2, rc5_last_command		; Befehl holen

		cpi		temp2, SPEED_UP				; Taste "Schneller" gedrckt?
		breq	_speed_up					; ja, Schneller

		cpi		temp2, SPEED_DOWN			; Taste "Langsamer" gedrckt?
		breq	_speed_down					; ja, Langsamer

		cpi		temp2, OPT_UP				; Taste "Option2+ = Maximalspeed" gedrckt?
		breq	_speed_max					; Ja, Maximalspeed

		cpi		temp2, OPT_DOWN				; Taste "Option2- = Minimalspeed" gedrckt?
		breq	_speed_min					; Ja, Minimalspeed

		rjmp	_set_speed_nochange			; anderer Befehl, keine nderung

_speed_max:

		ldi		temp1, 1					; Maximalspeed einstellen
		rjmp	_set_speed_ende				; und Ende

_speed_min:

		ldi		temp1, 255					; Minimalspeed einstellen
		rjmp	_set_speed_ende				; und Ende

_speed_down:

		cpi		temp1, 255					; Maximalwert schon erreicht...?
		breq	_set_speed_nochange			; ja, nicht ndern
		
		inc		temp1						; nein, erhhen
		rjmp	_set_speed_ende				; und Ende

_speed_up:

		cpi		temp1, 2					; Minimalwert schon erreicht...?
		brlo	_set_speed_nochange			; ja, nicht ndern
	
		dec		temp1						; nein, verringern

; ------------------------------------------------------------------------------------------------

_set_speed_ende:

_set_speed_nochange:

		ret

; ================================================================================================
